if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
		if(!$RTB::RTBR_ServerControl_Hook)
			exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
		RTB_registerPref("Allow Dizziness", "Player Collide", "Pref::PlayerCollide::Allow", "bool", "Script_PlayerCollide", 1, 0, 0);
		RTB_registerPref("Minigame Only?", "Player Collide", "Pref::PlayerCollide::MiniOnly", "bool", "Script_PlayerCollide", 1, 0, 0);
		RTB_registerPref("Allow Announce", "Player Collide", "Pref::PlayerCollide::Announce", "bool", "Script_PlayerCollide", 1, 0, 0);
}
else
{
	$Pref::PlayerCollide::Allow = true;
	$Pref::PlayerCollide::MiniOnly = true;
	$Pref::PlayerCollide::Announce = true;
}

datablock AudioProfile(StunCollideStunSound)
{
   filename    = "./StunCollide.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(StunCollideExplosion)
{
   explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 150;

   particleEmitter = "";
   particleDensity = 10;
   particleRadius = 0.2;
   
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 1.5;
   camShakeRadius = 1.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 0.2 0.0 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};

datablock ParticleData(StunCollideParticle)
{
   dragCoefficient      = 6.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   useInvAlpha          = true;
   textureName          = "base/data/particles/qmark";
   colors[0]     = "1.0 1.0 1.0 1.0";
   colors[1]     = "1.0 1.0 1.0 1.0";
   colors[2]     = "1.0 1.0 1.0 0.0";
   sizes[0]      = 0.6;
   sizes[1]      = 0.4;
   sizes[2]      = 0.4;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(StunCollideEmitter)
{
   ejectionPeriodMS = 60;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   ejectionOffset   = 0.9;
   velocityVariance = 0.49;
   thetaMin         = 0;
   thetaMax         = 120;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "StunCollideParticle";
};

datablock ShapeBaseImageData(StunCollideImage)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $HeadSlot;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 0.350;
	stateEmitter[1]					= StunCollideEmitter;
	stateEmitterTime[1]				= 10.350;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};

package PlayerCollide
{
	function Armor::onImpact(%this,%obj,%col,%pos,%speed)
 {
	parent::onImpact(%this,%obj,%col,%pos,%speed);
	if($Pref::PlayerCollide::Allow)
 {
	%mini = getMinigameFromObject(%col.client);
	%Collider = getMinigameFromObject(%obj.client);
	if(isObject(%mini) && isObject(%Collider) && $Pref::PlayerCollide::MiniOnly)
	{
  %class = %col.getClassName();
  if(%class $= "AiPlayer" || %class $= "Player")
  {
   %col.mountImage(StunCollideImage,0);
   serverPlay3d(StunCollideStunSound,%col.getposition());
   if($Pref::PlayerCollide::Announce)
   {
   messageall('',"" @ %col.client.name SPC "has been ran into and is now dizzy.");
   }
   
    if(isObject(%col.client))
    {
      %transform = %col.getTransform();
      %col.client.camera.setOrbitMode(%col, %transform, 0.5, 8, 8, 1);
      %col.client.camera.mode = "Orbit";
      %col.client.setControlObject(%col.client.camera);
	  %col.setWhiteout(2.0);
	  %col.setWhiteout(3.0);
    }
   %col.schedule(10000,unCollideStun);
   }
  }
   else if($Pref::PlayerCollide::MiniOnly == false)
	{
  %class = %col.getClassName();
  if(%class $= "AiPlayer" || %class $= "Player")
  {
   %col.mountImage(StunCollideImage,0);
   serverPlay3d(StunCollideStunSound,%col.getposition());
   if($Pref::PlayerCollide::Announce)
   {
   messageall('',"" @ %col.client.name SPC "has been ran into and is now dizzy.");
   }
   
    if(isObject(%col.client))
    {
      %transform = %col.getTransform();
      %col.client.camera.setOrbitMode(%col, %transform, 0.5, 8, 8, 1);
      %col.client.camera.mode = "Orbit";
      %col.client.setControlObject(%col.client.camera);
	  %col.setWhiteout(2.0);
	  %col.setWhiteout(3.0);
    }
   %col.schedule(10000,unCollideStun);
   }
  }
  }
 }
};
activatepackage(PlayerCollide);

function Player::unCollideStun(%this)
{
   if(%this.getState() $= "Dead")
      return;
   
   if(%this.getMountedImage(0) == StunCollideImage.getID())
      %this.unMountImage(0);
   
   %this.playThread(2,undo);
   
   %this.schedule(450,unCollideStun2);
}

function Player::unCollideStun2(%this)
{
   if(isObject(%this.client) && %this.getState() !$= "Dead")
   {
      %this.client.setcontrolobject(%this);
      if(%this.currTool != -1)
         servercmdUseTool(%this.client,%this.currTool);
   }
}

package PlayerCollideTool
{
   function servercmdusetool(%client,%slot)
   {
      if(%client.player.isBatStunned)
      {
         %client.player.currTool = %slot;
         return;
      }
      Parent::servercmdusetool(%client,%slot);
   }
   
   function servercmdunusetool(%client)
   {
      if(%client.player.isBatStunned)
         return;
      Parent::servercmdunusetool(%client);
   }
};
activatePackage(PlayerCollideTool);